#include "sync.h"

#include <QtDebug>

#include "client.h"

void Sync::startSync() {
    qDebug() << "trying initial sync";

    mtx::http::SyncOpts opts = {};
    opts.timeout = 0;
    http::client().sync(opts, [this](const mtx::responses::Sync &res, mtx::http::RequestErr err) {
        if (err) {
            qDebug() << "Failed sync";
            return;
        }

        for (const std::pair<std::string, mtx::responses::JoinedRoom> &join : res.rooms.join) {
            const mtx::responses::JoinedRoom &r = join.second;
            QSharedPointer<Room> room = QSharedPointer<Room>(new Room);

            room->name = join.first;

            qDebug() << QString::fromStdString(room->name);

            // room.picture = r.avatar();
            // room.tag = r.account_data.events.back(;
            room->unreadNotifications = r.unread_notifications.highlight_count;
            emit newRoom(room);
        }
    });
}
